﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace DataGridSample
{
    public sealed partial class MainPage
    {
        public MainPage()
        {
            InitializeComponent();
            DataGrid.ItemsSource = DataRepository.GetData();
        }
    }

    public class DataRepository
    {
        private static IList<Level1> _data;

        public static IList<Level1> GetData()
        {

            return _data ?? (_data = Enumerable.Range(0, 10).Select(x => new Level1
            {
                Id = x,
                Notes = String.Format("Notes {0}", x % 3),
                Level2Items = Enumerable.Range(0, 5).Select(y => new Level2
                {
                    Id = y,
                    Notes = String.Format("notes {0}: ", y),
                    Level3Items = Enumerable.Range(0, 5).Select(z =>
                        new Level3
                        {
                            Id = z,
                            Notes = String.Format("notes {0}: ", z),
                            Level4Items = Enumerable.Range(0, 10).Select(t => new Level4
                            {
                                Id = t,
                                Notes = String.Format("Notes: {0}", t)
                            }).ToList()

                        }).ToList()
                }).ToList(),
            }).ToList());
        }
    }

    public class Level1
    {
        public int Id { get; set; }
        public string Notes { get; set; }
        public string Level { get { return "Level1"; } }
        public IList<Level2> Level2Items { get; set; }
    }


    public class Level2
    {
        public int Id { get; set; }
        public string Notes { get; set; }
        public string Level { get { return "Level2"; } }
        public IList<Level3> Level3Items { get; set; }
    }

    public class Level3
    {
        public int Id { get; set; }
        public string Notes { get; set; }
        public string Level { get { return "Level3"; } }
        public IList<Level4> Level4Items { get; set; }
    }

    public class Level4
    {
        public int Id { get; set; }
        public string Notes { get; set; }
        public string Level { get { return "Level4"; } }
    }

}
